<?php
/* ========================================================================
 * Open eClass 2.6
 * E-learning and Course Management System
 * ========================================================================
 * Copyright 2003-2011  Greek Universities Network - GUnet
 * A full copyright notice can be read in "/info/copyright.txt".
 * For a full list of contributors, see "credits.txt".
 *
 * Open eClass is an open platform distributed in the hope that it will
 * be useful (without any warranty), under the terms of the GNU (General
 * Public License) as published by the Free Software Foundation.
 * The full license can be read in "/info/license/license_gpl.txt".
 *
 * Contact address: GUnet Asynchronous eLearning Group,
 *                  Network Operations Center, University of Athens,
 *                  Panepistimiopolis Ilissia, 15784, Athens, Greece
 *                  e-mail: info@openeclass.org
 * ======================================================================== */


/*===========================================================================
	addfaculte.php
	@last update: 12-07-2006 by Pitsiougas Vagelis
	@authors list: Karatzidis Stratos <kstratos@uom.gr>
		       Pitsiougas Vagelis <vagpits@uom.gr>
==============================================================================
        @Description: Manage Facultes

 	This script allows the administrator to list the available facultes, to
 	delete them or to make new ones.

 	The user can : - See the available facultes
 	               - Delete a faculte
 	               - Create a new faculte
 	               - Edit a faculte
                 - Return to main administrator page

 	@Comments: The script is organised in four sections.

  1) List of available facultes
  2) Add a new faculte
  3) Delete a faculte
  4) Display all on an HTML page

==============================================================================*/

// Check if user is administrator and if yes continue
// Othewise exit with appropriate message
$require_power_user = true;
// Include baseTheme
include '../../include/baseTheme.php';
// Define $nameTools
$nameTools = $langListFaculteActions;
$navigation[] = array('url' => 'index.php', 'name' => $langAdmin);

if (isset($_GET['a'])) {
        $navigation[] = array('url' => $_SERVER['SCRIPT_NAME'], 'name' => $langListFaculteActions);
	switch ($_GET['a']) {
		case 1:
			$nameTools = $langFaculteAdd;
			break;
		case 2:
			$nameTools = $langFaculteDel;
			break;
		case 3:
			$nameTools = $langFaculteEdit;
			break;
	}
}
// Give administrator a link to add a new faculty
$tool_content .= "
    <div id='operations_container'>
     <ul id='opslist'>
      <li><a href='$_SERVER[SCRIPT_NAME]?a=1'>".$langAdd."</a></li>
     </ul>
    </div>";

// Display all available faculties
if (!isset($_GET['a'])) {
	// Count available faculties
	$a = mysql_fetch_array(db_query("SELECT COUNT(*) FROM faculte"));
	// Construct a table
	$tool_content .= "
        <table width='100%' class='tbl_alt'>
	<tr>	
	<td colspan='4' class='right'>
		$langManyExist: <b>$a[0]</b> $langFaculties
	</td>
    	</tr><tr>
	<th scope='col' colspan='2'><div align='left'>&nbsp;&nbsp;".$langFaculty."</div></th scope='col'>
	<th scope='col' class='center'>$langCode</th>
	<th>".$langActions."</th>
	</tr>";
	$sql = db_query("SELECT code,name,id FROM faculte");
	$k = 0;
	// For all faculties display some info
	for ($j = 0; $j < mysql_num_rows($sql); $j++) {
		$logs = mysql_fetch_array($sql);
		if ($k%2==0) {
			$tool_content .= "\n<tr>";
		} else {
			$tool_content .= "\n<tr class='odd'>";
		}
		$tool_content .= "\n<td width='1'>
		<img src='$themeimg/arrow.png' alt=''></td>";
		$tool_content .= "\n<td>".htmlspecialchars($logs[1])."</td>";
		$tool_content .= "\n<td width='100' class='smaller center'>".htmlspecialchars($logs[0])."</td>";
		// Give administrator a link to delete or edit a faculty
		$tool_content .= "\n<td width='50' align='center' nowrap>
		<a href='$_SERVER[SCRIPT_NAME]?a=2&amp;c=".$logs['id']."'>
		<img src='$themeimg/delete.png' title='".q($langDelete)."' /></a>&nbsp;&nbsp;
		<a href='$_SERVER[SCRIPT_NAME]?a=3&amp;c=".$logs['id']."'>
		<img src='$themeimg/edit.png' title='".q($langEdit)."' /></a></td>
		</tr>\n";
		$k++;
	}
	// Close table correctly
	$tool_content .= "</table>\n";
	$tool_content .= "<br /><p class='right'><a href=\"index.php\">".$langBack."</a></p>";
}
// Add a new faculty
elseif (isset($_GET['a']) and $_GET['a'] == 1)  {
	if (isset($_POST['add'])) {
		$codefaculte = $_POST['codefaculte'];
		$faculte = $_POST['faculte'];
		// Check for empty fields
		if (empty($codefaculte) or empty($faculte)) {
			$tool_content .= "<p class='caution'>".$langEmptyFaculte."<br />";
			$tool_content .= "
			<a href=\"$_SERVER[SCRIPT_NAME]?a=1\">".$langReturnToAddFaculte."</a></p>";
			}
		// Check for greek letters
		elseif (!preg_match("/^[A-Z0-9a-z_-]+$/", $codefaculte)) {
			$tool_content .= "<p class='caution'>".$langGreekCode."<br />";
			$tool_content .= "<a href=\"$_SERVER[SCRIPT_NAME]?a=1\">".$langReturnToAddFaculte."</a></p>";
			}
		// Check if faculty code already exists
		elseif (mysql_num_rows(db_query("SELECT * from faculte WHERE code=" . autoquote($codefaculte))) > 0) {
			$tool_content .= "<p class='caution'>".$langFCodeExists."<br />";
			$tool_content .= "<a href=\"$_SERVER[SCRIPT_NAME]?a=1\">".$langReturnToAddFaculte."</a></p>";
			}
		// Check if faculty name already exists
		elseif (mysql_num_rows(db_query("SELECT * from faculte WHERE name=" . autoquote($faculte))) > 0) {
			$tool_content .= "<p class='caution'>".$langFaculteExists."<br />";
			$tool_content .= "<a href=\"$_SERVER[SCRIPT_NAME]?a=1\">".$langReturnToAddFaculte."</a></p>";
		} else {
		// OK Create the new faculty
			db_query("INSERT into faculte(code,name,generator,number) VALUES(" . autoquote($codefaculte) . ',' . autoquote($faculte) . ",'100','1000')")
				or die ($langNoSuccess);
			$tool_content .= "<p class='success'>".$langAddSuccess."</p>";
			}
	} else {
		// Display form for new faculty information
		$tool_content .= "
        <form method=\"post\" action=\"".$_SERVER['SCRIPT_NAME']."?a=1\">
        <fieldset>
          <legend>$langFaculteIns</legend>
          <table width='100%' class='tbl'>
	  <tr>
            <th width=\"180\" class='left'>".$langCodeFaculte1.":</th>
	    <td><input type='text' name='codefaculte' value='".@$codefaculte."' /> <i>".$langCodeFaculte2."</i></td>
	  </tr>
	  <tr>
	    <th class='left'>".$langFaculty.":</th>
	    <td><input type='text' name='faculte' value='".@$faculte."' /> <i>".$langFaculte2."</i></td>
          </tr>
	  <tr>
	    <th>&nbsp;</th>
	    <td class='right'><input type='submit' name='add' value='".q($langAdd)."' /></td>
	  </tr>
	</table>
        </fieldset>
	</form>";
	}
	$tool_content .= "<p align='right'><a href='$_SERVER[SCRIPT_NAME]'>".$langBack."</a></p>";
}
// Delete faculty
elseif (isset($_GET['a']) and $_GET['a'] == 2)  {
        $c = intval($_GET['c']);
	$s = db_query("SELECT * from cours WHERE faculteid = $c");
	// Check for existing courses of a faculty
	if (mysql_num_rows($s) > 0)  {
		// The faculty cannot be deleted
		$tool_content .= "<p>".$langProErase."</p><br />";
		$tool_content .= "<p>".$langNoErase."</p><br />";
	} else {
		// The faculty can be deleted
		db_query("DELETE FROM faculte WHERE id = $c");
		$tool_content .= "<p class='success'>$langErase</p>";
	}
	$tool_content .= "<p align='right'><a href='$_SERVER[SCRIPT_NAME]'>".$langBack."</a></p>";
}
// Edit a faculty
elseif (isset($_GET['a']) and $_GET['a'] == 3)  {
        $c = intval($_REQUEST['c']);
	if (isset($_POST['edit'])) {
		// Check for empty fields
                $faculte = $_POST['faculte'];
		if (empty($faculte)) {
			$tool_content .= "<p class='caution'>".$langEmptyFaculte."<br />";
			$tool_content .= "<a href='$_SERVER[SCRIPT_NAME]?a=3&amp;c=$c'>$langReturnToEditFaculte</a></p>";
                }
		// Check if faculty name already exists
		elseif (mysql_num_rows(db_query("SELECT * from faculte WHERE id <> $c
					AND name=" . autoquote($faculte))) > 0) {
			$tool_content .= "<p class='caution'>".$langFaculteExists."<br />";
			$tool_content .= "<a href='$_SERVER[SCRIPT_NAME]?a=3&amp;c=$c'>$langReturnToEditFaculte</a></p>";
		} else {
                        // OK Update the faculty
			db_query("UPDATE faculte SET name = " .
                                         autoquote($faculte) . " WHERE id=$c")
                                 or die ($langNoSuccess);
			$tool_content .= "<p class='success'>$langEditFacSucces</p><br />";
                }
	} else {
		// Get faculty information
                $c = intval($_GET['c']);
		$sql = "SELECT code, name FROM faculte WHERE id=$c";
		$result = db_query($sql);
		$myrow = mysql_fetch_array($result);
		// Display form for edit faculty information
		$tool_content .= "
           <form method='post' action='$_SERVER[SCRIPT_NAME]?a=3'>
           <fieldset>
           <legend>$langFaculteEdit</legend>
           <table width='100%' class='tbl'>
	   <tr>
		<th class='left' width='180'>".$langCodeFaculte1.":</th>
		<td><input type='text' name='codefaculte' value='".$myrow['code']."' readonly='1' />&nbsp;<i>".$langCodeFaculte2."</i></td>
	   </tr>
	   <tr>
		<th class='left'>".$langFaculty.":</th>
		<td><input type='text' name='faculte' value='".htmlspecialchars($myrow['name'], ENT_QUOTES)."' />&nbsp;<i>".$langFaculte2."</i></td>
	   </tr>
	   <tr>
		<th>&nbsp;</th>
		<td class='right'><input type='hidden' name='c' value='$c' />
		<input type='submit' name='edit' value='".q($langAcceptChanges)."' />
		</td>
	   </tr>
	   </table>
           </fieldset>
	   </form>";
	}
$tool_content .= "<p align='right'><a href='$_SERVER[SCRIPT_NAME]'>".$langBack."</a></p>";
}

draw($tool_content, 3);
